var landing = implement("smp:external/superhero_landing");

function init(hero) {
    hero.setName("Sculk Monarch");
    hero.setTier(9);
    
    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:sculk_infection");
    hero.addAttribute("PUNCH_DAMAGE", 10, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.7, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);
    hero.addAttribute("SPRINT_SPEED", 0.3, 1);
    hero.addAttribute("WEAPON_DAMAGE", -0.95, 1);

    hero.addKeyBind("ENERGY_PROJECTION", "Infectious Beams", 2);
    hero.addKeyBind("CHARGED_BEAM", "Sculk Shreik", 1);
    hero.addKeyBind("GRAVITY_MANIPULATION", "Sculk Pulse", 3);
    hero.addKeyBind("TELEPORT", "Blink", 4);

    hero.setKeyBindEnabled(isKeyBindEnabled);

    hero.setTickHandler((entity, manager) => {
        landing.tick(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "CHARGED_BEAM":
        return !entity.getData("fiskheroes:energy_projection");
    case "ENERGY_PROJECTION":
        return !entity.getData("fiskheroes:beam_charging");
    default:
        return true;
    }
}

function hasProperty(entity, property) {
    return property == "BREATHE_SPACE";
}
